/* Make a "hidden" string. */
#include <stdio.h>
#include <stdlib.h>

usage()
{
   puts("Usage:  makehidn outfile strname part \"the string to encrypt\"");
   puts(" For hiding a string inside of a C program.");
   puts(" 'strname' is the name of the C char array");
   puts("  part of '1' means 1st of many parts.");
   puts("  part of '2' means middle of many parts.");
   puts("  part of '4' means last of many parts.");
   puts("  part of '5' means this is the one and only part.");
   puts("    These parts all get appended to the outfile.");
   puts("  '~' in the string means 'newline'");
   exit(EXIT_FAILURE);
}

FILE *fp = stdout;
unsigned char encr[100] = "";
main(int argc, unsigned char **argv)
{
   unsigned char *ci, *co, *end;
   unsigned char x, ch;
   int i;
   #define FRST 1
   #define MID 2
   #define LAST 4
   int type = FRST + MID + LAST;


   if (argc != 5)
      usage();
   /* See if this is a long string */
   type = atoi(argv[3]);

   co = encr;
   for (ch = x = 0xa5, ci = argv[4]; ch != 0; ) {
      ch = *ci;
      if (ch == '\\') {
	 switch ( *++ci ) {
	 case 'n': ch = '\n'; break;
	 case 'r': ch = '\r'; break;
	 case 'b': ch = '\b'; break;
	 case '0': ch = '\0'; break;
	 default: ch = *ci;
	 }
      }
      *co = ch ^ x;
      ++co;
      ++ci;
   }

   *co = '\0';
   end = co;
   if ((type & LAST) != LAST)
   --end;
   
   if ((type & FRST) == FRST)
      fp = fopen(argv[1], "w");
   else
      fp = fopen(argv[1], "a");
   if (fp == NULL) {
      fprintf(stderr, "Can't open for write: %s\n", argv[1]);
      exit(EXIT_FAILURE);
   }

   if ((type & FRST) == FRST)
      fprintf(fp, "unsigned char %s[] = {\n", argv[2]);
   for (i = 10, co = encr; co != end; ++co) {
      fprintf(fp, "0x%02x, ", *co);
      if (--i == 0) {
	 i = 10;
	 fprintf(fp, "\n");
      }
   }
   if ((type & LAST) == LAST)
      fprintf(fp, "0 };");
   fprintf(fp, "\n");
   fclose(fp);

#ifdef DEBUG
   puts("Print it back out...");
   for (x = 0xa5, ci = encr; ;++ci) {
      ch = *ci ^ x;
//      x ^= ch;
      if (ch == 0)
	 break;
      putchar(ch);
   }
   puts("\n----30----");
#endif   
   return(EXIT_SUCCESS);
}

